# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define javasigneddir %{_javadir}-signed
%define _jarsign_opts --nocopy --sign=%{javasigneddir}

%bcond_with repolib
%bcond_with build_time

%define repodir %{_javadir}/repository.jboss.com/asm/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src
%define section free
%define base_name objectweb-asm

Name:           objectweb-asm31
Version:        3.1
### NOTE: Please tag this pkg for dist-5E-ep-maven221 every time it is built.
Release:        12.1%{?dist}
Epoch:          0
Summary:        Code manipulation tool to implement adaptable systems
License:        BSD
URL:            http://asm.objectweb.org/
Group:          Development/Libraries/Java
Source0:        http://download.forge.objectweb.org/asm/asm-3.1.tar.gz
Source1:        http://repo1.maven.org/maven2/asm/asm/3.1/asm-3.1.pom
Source2:        http://repo1.maven.org/maven2/asm/asm-analysis/3.1/asm-analysis-3.1.pom
Source3:        http://repo1.maven.org/maven2/asm/asm-commons/3.1/asm-commons-3.1.pom
Source4:        http://repo1.maven.org/maven2/asm/asm-tree/3.1/asm-tree-3.1.pom
Source5:        http://repo1.maven.org/maven2/asm/asm-util/3.1/asm-util-3.1.pom
Source6:        http://repo1.maven.org/maven2/asm/asm-xml/3.1/asm-xml-3.1.pom
Source7:        http://repo1.maven.org/maven2/asm/asm-all/3.1/asm-all-3.1.pom
Source8:        http://repo1.maven.org/maven2/asm/asm-parent/3.1/asm-parent-3.1.pom
Source9:        asm-MANIFEST.MF
Source10:       asm-component-info.xml
Source11:       objectweb-asm-upload.sh
Patch0:         objectweb-asm-no-classpath-in-manifest.patch
# Needed by asm-xml.jar

Requires:       xml-commons-jaxp-1.3-apis
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3

Provides:       objectweb-asm = 0:3.1-10

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  objectweb-anttask
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  zip
# To create content for maven2-brew
BuildRequires:  maven-deploy-plugin

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
ASM is a code manipulation tool to implement adaptable systems.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n asm-%{version}
%patch0 -p1
perl -pi -e 's/\r$//g' LICENSE.txt README.txt

mkdir META-INF
cp -p %{SOURCE9} META-INF/MANIFEST.MF

%build
export CLASSPATH=
export OPT_JAR_LIST=:
ant -Dobjectweb.ant.tasks.path=$(build-classpath objectweb-anttask) jar jdoc

%install
rm -rf $RPM_BUILD_ROOT

# On RHEL-6 the signed JARs are on a different place
export JPP_SIGNED=2

# jars
install -d -m 755 $RPM_BUILD_ROOT%{javasigneddir}/%{base_name}

for jar in output/dist/lib/*.jar; do
install -p -m 644 ${jar} $RPM_BUILD_ROOT%{javasigneddir}/%{base_name}/`basename ${jar}`
done

touch META-INF/MANIFEST.MF
jar -u output/dist/lib/all/asm-all-%{version}.jar META-INF/MANIFEST.MF

install -p -m 644 output/dist/lib/all/asm-all-%{version}.jar $RPM_BUILD_ROOT%{javasigneddir}/%{base_name}/

(cd $RPM_BUILD_ROOT%{javasigneddir}/%{base_name} && for jar in *-%{version}*; do \
ln -s ${jar} ${jar/-%{version}/}; done)

# pom
%if %with build_time
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm.pom
%add_to_maven_depmap org.objectweb.asm asm %{version} JPP/objectweb-asm asm
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-analysis.pom
%add_to_maven_depmap org.objectweb.asm asm-analysis %{version} JPP/objectweb-asm asm-analysis
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-commons.pom
%add_to_maven_depmap org.objectweb.asm asm-commons %{version} JPP/objectweb-asm asm-commons
install -p -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-tree.pom
%add_to_maven_depmap org.objectweb.asm asm-tree %{version} JPP/objectweb-asm asm-tree
install -p -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-util.pom
%add_to_maven_depmap org.objectweb.asm asm-util %{version} JPP/objectweb-asm asm-util
install -p -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-xml.pom
%add_to_maven_depmap org.objectweb.asm asm-xml %{version} JPP/objectweb-asm asm-xml
install -p -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-all.pom
%add_to_maven_depmap org.objectweb.asm asm-all %{version} JPP/objectweb-asm asm-all
install -p -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-parent.pom
%add_to_maven_depmap org.objectweb.asm asm-parent %{version} JPP/objectweb-asm asm-parent
%endif

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/dist/doc/javadoc/user/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{repodirlib}/asm.pom

cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm-analysis.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{repodirlib}/asm-analysis.pom

cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm-commons.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{repodirlib}/asm-commons.pom

cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm-tree.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE4} $RPM_BUILD_ROOT%{repodirlib}/asm-tree.pom

cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm-util.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE5} $RPM_BUILD_ROOT%{repodirlib}/asm-util.pom

cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm-xml.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE6} $RPM_BUILD_ROOT%{repodirlib}/asm-xml.pom

cp -p $RPM_BUILD_ROOT%{javasigneddir}/objectweb-asm/asm-all.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE7} $RPM_BUILD_ROOT%{repodirlib}/asm-all.pom

cp -p %{SOURCE8} $RPM_BUILD_ROOT%{repodirlib}/asm-parent.pom

install -p -m 755 %{SOURCE11} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/ 
# FIXME Add workaround for nasty deploy-file bug that causes minimal asm-parent.pom
cp -p lib/asm-parent.pom %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/org/objectweb/asm/asm-parent/3.1/asm-parent-3.1.pom
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %with build_time
%post
%update_maven_depmap

%postun
%update_maven_depmap
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt README.txt
%dir %{javasigneddir}*/%{base_name}
%{javasigneddir}*/%{base_name}/asm-all-%{version}.jar
%{javasigneddir}*/%{base_name}/asm-all.jar
%{javasigneddir}*/%{base_name}/asm-analysis-%{version}.jar
%{javasigneddir}*/%{base_name}/asm-analysis.jar
%{javasigneddir}*/%{base_name}/asm-commons-%{version}.jar
%{javasigneddir}*/%{base_name}/asm-commons.jar
%{javasigneddir}*/%{base_name}/asm-tree-%{version}.jar
%{javasigneddir}*/%{base_name}/asm-tree.jar
%{javasigneddir}*/%{base_name}/asm-util-%{version}.jar
%{javasigneddir}*/%{base_name}/asm-util.jar
%{javasigneddir}*/%{base_name}/asm-xml-%{version}.jar
%{javasigneddir}*/%{base_name}/asm-xml.jar
%{javasigneddir}*/%{base_name}/asm-%{version}.jar
%{javasigneddir}*/%{base_name}/asm.jar
%if %with build_time
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-all.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-analysis.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-commons.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-parent.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-tree.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-util.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm-xml.pom
%{_datadir}/maven2/poms/JPP.objectweb-asm-asm.pom
%{_mavendepmapfragdir}/%{name}
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu May 26 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.1-12.1
- Add Provides: objectweb-asm

* Wed May 25 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.1-12
- Remove poms and depmaps since this is a run-time only package

* Tue May 24 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.1-11
- First build
- Install jar files to %{_javadir}-signed only
